## visad.util
Class ColorMap

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JPanel
                      visad.util.ColorMap

All Implemented Interfaces:
  Accessible, ImageObserver, MenuContainer, Serializable

Direct Known Subclasses:
  BaseRGBMap

public abstract class ColorMap
extends JPanel

The abstract class that all color-mapping widgets must extend. This class manages all of the listener notification for the ColorMaps.

Since:
  Visad Utility Library, 0.5
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class javax.swing.JPanel
`JPanel.AccessibleJPanel`

Nested classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Container
``

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`ColorMap()`

Method Summary
`void` `addColorChangeListener(ColorChangeListener c)` Add a ColorChangeListener to the listeners list
`Color` `getColor(float value)` Maps a floating point value (in the range 0 to 1) onto a Color, returns Color.black if the number is out of range If you're getting more than 1 or 2 colors, use getColors() instead.
`abstract float[][]` `getColorMap()` Returns a copy of the ColorMap
`Color[]` `getColors(float start, float end, int num)` Map a range of floating point values (in the range 0 to 1) onto a range of Colors.
`abstract int` `getMapDimension()` Returns the dimension of the map
`abstract int` `getMapResolution()` Returns the current map resolution
`abstract float[]` `getRGBTuple(float value)` Maps a floating point value (in the range 0 to 1) onto an RGB triplet of floating point numbers in the range 0 to 1) If you're getting more than 1 or 2 tuples, use getRGBTuples() instead.
`abstract float[][]` `getRGBTuples(float start, float end, int count)` Maps the specified floating point values (in the range 0 to 1) onto a group of RGB triplets of floating point numbers in the range 0 to 1.
`abstract float[]` `getTuple(float value)` Maps a floating point value (in the range 0 to 1) into a tuple with dimension of the map If you're getting more than 1 or 2 tuples, use getTuples() instead.
`abstract float[][]` `getTuples(float start, float end, int count)` Maps the specified floating point values (in the range 0 to 1) onto a group of floating point tuples with the dimension of the map.
`protected void` `notifyListeners(ColorChangeEvent e)` Notify the ColorChangeListerers that the color widget has changed
`void` `removeColorChangeListener(ColorChangeListener c)` Remove a ColorChangeListener from the listeners list

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ColorMap

    public ColorMap()

Method Detail

### getColor

    public Color getColor(float value)

  Maps a floating point value (in the range 0 to 1) onto a Color, returns Color.black if the number is out of range If you're getting more than 1 or 2 colors, use getColors() instead.

### getColors

    public Color[] getColors(float start,
                             float end,
                             int num)

  Map a range of floating point values (in the range 0 to 1) onto a range of Colors.

### getRGBTuple

    public abstract float[] getRGBTuple(float value)

  Maps a floating point value (in the range 0 to 1) onto an RGB triplet of floating point numbers in the range 0 to 1) If you're getting more than 1 or 2 tuples, use getRGBTuples() instead.

### getRGBTuples

    public abstract float[][] getRGBTuples(float start,
                                           float end,
                                           int count)

  Maps the specified floating point values (in the range 0 to 1) onto a group of RGB triplets of floating point numbers in the range 0 to 1. The endpoints are included in `count` so if `count=1`, only the RGBTuple for `start` is returned; if `count=3`, then RGBTuples are returned for `start`, the midpoint between `start` and `end, and for `end`.

  `
  Parameters:
    `start` - the first value to translate
    `end` - the last value to translate
    `count` - the number of values (including the two endpoints) to be returned.

### getTuple

    public abstract float[] getTuple(float value)

  Maps a floating point value (in the range 0 to 1) into a tuple with dimension of the map If you're getting more than 1 or 2 tuples, use getTuples() instead.

### getTuples

    public abstract float[][] getTuples(float start,
                                        float end,
                                        int count)

  Maps the specified floating point values (in the range 0 to 1) onto a group of floating point tuples with the dimension of the map. The endpoints are included in `count` so if `count=1`, only the tuple for `start` is returned; if `count=3`, then tuples are returned for `start`, the midpoint between `start` and `end, and for `end`.

  `
  Parameters:
    `start` - The first value to translate
    `end` - The last value to translate
    `count` - The number of values (including the two endpoints) to be returned.

### getMapResolution

    public abstract int getMapResolution()

  Returns the current map resolution

### getMapDimension

    public abstract int getMapDimension()

  Returns the dimension of the map

### getColorMap

    public abstract float[][] getColorMap()

  Returns a copy of the ColorMap

### addColorChangeListener

    public void addColorChangeListener(ColorChangeListener c)

  Add a ColorChangeListener to the listeners list

### removeColorChangeListener

    public void removeColorChangeListener(ColorChangeListener c)

  Remove a ColorChangeListener from the listeners list

### notifyListeners

    protected void notifyListeners(ColorChangeEvent e)

  Notify the ColorChangeListerers that the color widget has changed